//+------------------------------------------------------------------+
//|                                                      Acdat01.mq4 |
//+------------------------------------------------------------------+

//---- input parameters

extern double    lots = 0.5;
extern double    trailingstop = 15;
extern int       stoploss = 40;
extern int       takeprofit = 185;
extern int       fma = 8;
extern int       sma = 16;
extern int       openlevel = 20;
extern int       closelevel = 80;

static int       prevtime = 0;
static double    prof = 0;
static bool      trend = 0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

int init()
  {
//----   
//----   
   return(0); 
  }
  
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+

int deinit()
  {
//----   
//----   
   return(0);  
  }
  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start()
   {
   if (Time[0] == prevtime) return(0);
   prevtime = Time[0];

   double rsi = iRSI(NULL, 0, 16, PRICE_CLOSE, 0);

   double iT1 = iCustom(NULL,0,"i_Trend",0,0,0,20,2,13,300,0,0);
   double iT2 = iCustom(NULL,0,"i_Trend",0,0,0,20,2,13,300,0,1);
   
   double maf = iMA(NULL, 0, fma, 0, MODE_SMA, PRICE_CLOSE, 0);
   double mas = iMA(NULL, 0, sma, 0, MODE_SMA, PRICE_CLOSE, 0);
   double madif = maf - mas; 
   
   if (madif > 0) trend = 1; else trend = 0;   
   
   if (OrdersTotal() < 1) 
   {
      int res = 0;
      if ( trend == 1 && Close[1] > Open[1] && Close[0] > Open[0] ) // Trend is UP
      {
         res = OrderSend(Symbol(), OP_BUY, lots ,Ask, 3, Ask - stoploss * Point, Bid + takeprofit * Point, "b2o", 888, 0, Blue);
         Print("B2O ", mas, maf);
         return(0);
      }  // --->  this one here was missing in your correction

      if ( trend == 0 && Close[1] < Open[1] && Close[0] < Open[0] ) // Trend is DOWN
      {
         res = OrderSend(Symbol(), OP_SELL, lots ,Bid, 3, Bid + stoploss * Point, Ask - takeprofit * Point, "s2o", 888, 0, Red);
         Print("S2O ", mas, maf);
         return(0);
      }
   } 
   else 
   {
      if (OrdersTotal() > 1) return(0);
 
      OrderSelect(0, SELECT_BY_POS, MODE_TRADES);
      prof = OrderProfit();   
      
// --->    }   this one here was in the wrong place ... :)

      if (OrderType() == OP_BUY  && prof > takeprofit)
      {
         res = OrderSend(Symbol(), OP_SELL, lots ,Bid, 3, Bid + stoploss * Point, Ask - takeprofit * Point, "s2c", 888, 0, Yellow);
         Print("S2C ", prof);
         return(0);
      }
      
      if (OrderType() == OP_SELL && prof > takeprofit)
      {
         res = OrderSend(Symbol(), OP_BUY, lots ,Ask, 3, Ask - stoploss * Point, Bid + takeprofit * Point, "b2c", 888, 0, Green);
         Print("B2C ", prof);         
         return(0);
      }
      
      if (OrderType() == OP_BUY) // Check trailing stops 
      {
         if (trailingstop > 0) 
         {                
            if ((Bid - OrderOpenPrice()) > (Point*(trailingstop+0.5)))
            {
               if (OrderStopLoss() < ((Bid - Point*(trailingstop+0.5))) ||
                  (OrderStopLoss() == 0)) 
               {
                  OrderModify(OrderTicket(), OrderOpenPrice(),
                  Bid - (Point*trailingstop), OrderTakeProfit(), 0, Green);
                  Print(prof);    
                  return(0);
               }
            }
         }
      }
      
      if (OrderType() == OP_SELL) // Check trailing stops 
      {
         if (trailingstop > 0) 
         {                
            if ((OrderOpenPrice() - Ask) > (Point*(trailingstop+0.5)))
            {
               if ((OrderStopLoss() > (Ask + Point*(trailingstop+0.5))) ||
                  (OrderStopLoss() == 0))
               {
                  OrderModify(OrderTicket(), OrderOpenPrice(),
                  Ask + (Point*trailingstop), OrderTakeProfit(), 0, Red);
                  Print(prof);                     
                  return(0);
               }
            }
         }
      }
   }

//----

   return(0);
   }
  
//+------------------------------------------------------------------+


